diff -Naur src.pgsql/backend/access/bitmap/bitmapxlog.c src.bizgres/backend/access/bitmap/bitmapxlog.c
--- src.pgsql/backend/access/bitmap/bitmapxlog.c	1969-12-31 16:00:00.000000000 -0800
+++ src.bizgres/backend/access/bitmap/bitmapxlog.c	2006-07-17 22:33:21.000000000 -0700
@@ -0,0 +1,469 @@
+/*-------------------------------------------------------------------------
+ *
+ * bitmapxlog.c
+ *	WAL replay logic for the bitmap index.
+ *
+ * Copyright (c) 2006, Greenplum, Inc.
+ *
+ * IDENTIFICATION
+ *	$PostgreSQL$
+ *
+ *-------------------------------------------------------------------------
+ */
+#include "postgres.h"
+
+#include <unistd.h>
+
+#include "access/bitmap.h"
+#include "access/xlogutils.h"
+
+/*
+ * _bitmap_xlog_newpage() -- create a new page.
+ */
+static void
+_bitmap_xlog_newpage(bool redo, XLogRecPtr lsn, XLogRecord *record)
+{
+	xl_bm_newpage	*xlrec = (xl_bm_newpage*) XLogRecGetData(record);
+
+	Relation		reln;
+	Page			page;
+	uint8			info;
+
+	info = record->xl_info & ~XLR_INFO_MASK;
+
+	reln = XLogOpenRelation(xlrec->bm_node);
+	if (!RelationIsValid(reln))
+		return;
+
+	if (redo)
+	{
+		Buffer		buffer;
+
+		buffer = XLogReadBuffer(reln, xlrec->bm_new_blkno, true);
+		if (!BufferIsValid(buffer))
+			elog(PANIC, "bm_insert_redo: block unfound: %d", 
+				 xlrec->bm_new_blkno);
+
+		page = BufferGetPage(buffer);
+
+		if (XLByteLT(PageGetLSN(page), lsn))
+		{
+			Buffer		metabuf;
+			BMMetaPage	metapage;
+
+			switch (info)
+			{
+				case XLOG_BITMAP_INSERT_NEWLOV:
+					_bitmap_init_lovpage(reln, buffer);
+					break;
+				case XLOG_BITMAP_INSERT_NEWBITMAP:
+					_bitmap_init_bitmappage(reln, buffer);
+					break;
+				default:
+					elog(PANIC, "bitmap_redo: unknown newpage op code %u", info);
+			}
+
+			PageSetLSN(page, lsn);
+			PageSetTLI(page, ThisTimeLineID);
+			_bitmap_wrtbuf(buffer);
+
+			metabuf = XLogReadBuffer(reln, BM_METAPAGE, true);
+			if (!BufferIsValid(metabuf))
+				elog(PANIC, "bm_insert_redo: block unfound: %d", BM_METAPAGE);
+			metapage = (BMMetaPage)BufferGetPage(metabuf);
+
+			if (XLByteLT(PageGetLSN(metapage), lsn))
+			{
+				PageSetLSN(metapage, lsn);
+				PageSetTLI(metapage, ThisTimeLineID);
+				_bitmap_wrtbuf(metabuf);
+			}
+			else
+				_bitmap_relbuf(metabuf);
+		}
+
+		else {
+			_bitmap_relbuf(buffer);
+		}
+	}
+	else
+		elog(PANIC, "bm_insert_undo: not implemented.");
+}
+
+/*
+ * _bitmap_xlog_insert_lovitem() -- insert a new lov item.
+ */
+static void
+_bitmap_xlog_insert_lovitem(bool redo, XLogRecPtr lsn, XLogRecord* record)
+{
+	xl_bm_lovitem	*xlrec = (xl_bm_lovitem*) XLogRecGetData(record);
+	Relation reln;
+
+	reln = XLogOpenRelation(xlrec->bm_node);
+	if (!RelationIsValid(reln))
+		return;
+
+	if (redo)
+	{
+		Buffer			lovBuffer;
+		Page			lovPage;
+
+		lovBuffer = XLogReadBuffer(reln, xlrec->bm_lov_blkno, false);
+		if (!BufferIsValid(lovBuffer))
+			elog(PANIC, "bm_insert_redo: block unfound: %d",
+				 xlrec->bm_lov_blkno);
+
+		lovPage = BufferGetPage(lovBuffer);
+
+		if (XLByteLT(PageGetLSN(lovPage), lsn))
+		{
+			if(xlrec->bm_isNewItem)
+			{
+				OffsetNumber	newOffset, itemSize;
+
+				newOffset = OffsetNumberNext(PageGetMaxOffsetNumber(lovPage));
+				if (newOffset != xlrec->bm_lov_offset)
+					elog(PANIC, "bm_insert_redo: LOV item is not inserted "
+								"in pos %d(requested %d)",
+						 newOffset, xlrec->bm_lov_offset);
+
+				itemSize = sizeof(BMLOVItemData);
+				if (itemSize > PageGetFreeSpace(lovPage))
+					elog(PANIC, 
+						 "bm_insert_redo: not enough space in LOV page %d",
+						 xlrec->bm_lov_blkno);
+		
+				if (PageAddItem(lovPage, (Item)&(xlrec->bm_lovItem), itemSize, 
+								newOffset, LP_USED) == InvalidOffsetNumber)
+					ereport(ERROR,
+							(errcode(ERRCODE_INTERNAL_ERROR),
+							errmsg("failed to add LOV item to \"%s\"",
+							RelationGetRelationName(reln))));
+			}
+
+			else{
+				BMLOVItem oldLovItem;
+				oldLovItem = (BMLOVItem)
+					PageGetItem(lovPage, 
+								PageGetItemId(lovPage, xlrec->bm_lov_offset));
+
+				memcpy(oldLovItem, &(xlrec->bm_lovItem), sizeof(BMLOVItemData));
+			}
+
+			PageSetLSN(lovPage, lsn);
+			PageSetTLI(lovPage, ThisTimeLineID);
+			_bitmap_wrtbuf(lovBuffer);
+		}
+
+		else {
+			_bitmap_relbuf(lovBuffer);
+		}
+	}
+
+	else
+		elog(PANIC, "bm_insert_undo: not implemented.");
+}
+
+/*
+ * _bitmap_xlog_insert_meta() -- update a metapage.
+ */
+static void
+_bitmap_xlog_insert_meta(bool redo, XLogRecPtr lsn, XLogRecord* record)
+{
+	xl_bm_metapage	*xlrec = (xl_bm_metapage*) XLogRecGetData(record);
+	Relation		reln;
+
+	reln = XLogOpenRelation(xlrec->bm_node);
+	
+	if (!RelationIsValid(reln))
+		return;
+
+	if (redo)
+	{
+		Buffer			metabuf;
+		BMMetaPage		metapage;
+
+		metabuf = XLogReadBuffer(reln, BM_METAPAGE, false);
+		if (!BufferIsValid(metabuf))
+			elog(PANIC, "bm_insert_redo: block unfound: %d", BM_METAPAGE);
+
+		/* restore the page */
+		metapage = (BMMetaPage)BufferGetPage(metabuf);
+
+		if (XLByteLT(PageGetLSN(metapage), lsn))
+		{
+			metapage->bm_num_tuples = xlrec->bm_num_tuples;
+			metapage->bm_lov_heapId = xlrec->bm_lov_heapId;
+			metapage->bm_lov_indexId = xlrec->bm_lov_indexId;
+			metapage->bm_lov_lastpage = xlrec->bm_lov_lastpage;
+			metapage->bm_need_rebuilt = xlrec->bm_need_rebuilt;
+
+			PageSetLSN(metapage, lsn);
+			PageSetTLI(metapage, ThisTimeLineID);
+			_bitmap_wrtbuf(metabuf);
+		}
+
+		else
+			_bitmap_relbuf(metabuf);
+	}
+
+	else
+		elog(PANIC, "bm_insert_undo: not implemented.");
+}
+
+/*
+ * _bitmap_xlog_insert_bitmap() -- update a bitmap page.
+ */
+static void
+_bitmap_xlog_insert_bitmap(bool redo, XLogRecPtr lsn, XLogRecord* record)
+{
+	xl_bm_bitmappage	*xlrec = (xl_bm_bitmappage*) XLogRecGetData(record);
+	Relation reln;
+
+	reln = XLogOpenRelation(xlrec->bm_node);
+	if (!RelationIsValid(reln))
+		return;
+
+	if (redo)
+	{
+		Buffer	bitmapBuffer;
+		Page	bitmapPage;
+		BMBitmapOpaque	bitmapPageOpaque ;
+
+		bitmapBuffer = XLogReadBuffer(reln, xlrec->bm_bitmap_blkno, false);
+		if (!BufferIsValid(bitmapBuffer))
+			elog(PANIC, "bm_insert_redo: block unfound: %d",
+				 xlrec->bm_bitmap_blkno);
+
+		bitmapPage = BufferGetPage(bitmapBuffer);
+
+		if (XLByteLT(PageGetLSN(bitmapPage), lsn))
+		{
+			BMBitmap	bitmap;
+			BM_HRL_WORD*	bitmapWords = (BM_HRL_WORD*)
+				(((char*)xlrec) + MAXALIGN(sizeof(xl_bm_bitmappage)));
+
+			bitmapPageOpaque =
+				(BMBitmapOpaque)PageGetSpecialPointer(bitmapPage);;
+			bitmap = (BMBitmap) PageGetContents(bitmapPage);
+
+			bitmapPageOpaque->bm_last_tid_location =
+				xlrec->bm_last_tid_location;
+			bitmapPageOpaque->bm_hrl_words_used =
+				xlrec->bm_hrl_words_used;
+
+			/* copy the header words and the content words */
+			memcpy(bitmap->bm_headerWords,
+				   xlrec->bm_headerWords,
+				   BM_MAX_NUM_OF_HEADER_WORDS*sizeof(BM_HRL_WORD));
+			memcpy((bitmap->bm_contentWords +
+					(bitmapPageOpaque->bm_hrl_words_used-
+					 xlrec->bm_num_words)),
+				   bitmapWords,
+				   xlrec->bm_num_words*sizeof(BM_HRL_WORD));
+
+			if (xlrec->bm_isOpaque)
+			{
+				/* copy the block number for the next page */
+				if (bitmapPageOpaque->bm_bitmap_next != InvalidBlockNumber)
+					elog(PANIC, 
+						"%s next bitmap page for blkno %d is already set",
+						"bm_insert_redo: ",
+						xlrec->bm_bitmap_blkno);
+				/*Assert(bitmapPageOpaque->bm_hrl_words_used == 
+						BM_NUM_OF_HRL_WORDS_PER_PAGE);*/
+
+				bitmapPageOpaque->bm_bitmap_next = xlrec->bm_next_blkno;
+			}
+
+			PageSetLSN(bitmapPage, lsn);
+			PageSetTLI(bitmapPage, ThisTimeLineID);
+			_bitmap_wrtbuf(bitmapBuffer);
+		}
+		else
+			_bitmap_relbuf(bitmapBuffer);
+	}
+
+	else
+		elog(PANIC, "bm_insert_undo: not implemented.");
+}
+
+/*
+ * _bitmap_xlog_insert_bitmap_lastwords() -- update the last two words
+ * in a bitmap vector.
+ */
+static void
+_bitmap_xlog_insert_bitmap_lastwords(bool redo, XLogRecPtr lsn, XLogRecord* record)
+{
+	xl_bm_bitmap_lastwords	*xlrec = 
+		(xl_bm_bitmap_lastwords*) XLogRecGetData(record);
+	Relation reln;
+
+	reln = XLogOpenRelation(xlrec->bm_node);
+	if (!RelationIsValid(reln))
+		return;
+
+	if (redo)
+	{
+		Buffer		lovBuffer;
+		Page		lovPage;
+		BMLOVItem	lovItem;
+
+		lovBuffer = XLogReadBuffer(reln, xlrec->bm_lov_blkno, false);
+		if (!BufferIsValid(lovBuffer))
+			elog(PANIC, "bm_insert_redo: block unfound: %d",
+				 xlrec->bm_lov_blkno);
+
+		lovPage = BufferGetPage(lovBuffer);
+
+		if (XLByteLT(PageGetLSN(lovPage), lsn))
+		{
+			lovItem = (BMLOVItem)
+				PageGetItem(lovPage, PageGetItemId(lovPage, xlrec->bm_lov_offset));
+
+			lovItem->bm_last_compword = xlrec->bm_last_compword;
+			lovItem->bm_last_word = xlrec->bm_last_word;
+			lovItem->bm_last_two_headerbits = xlrec->bm_last_two_headerbits;
+
+			PageSetLSN(lovPage, lsn);
+			PageSetTLI(lovPage, ThisTimeLineID);
+			_bitmap_wrtbuf(lovBuffer);
+		}
+
+		else
+			_bitmap_relbuf(lovBuffer);
+	}
+
+	else
+		elog(PANIC, "bm_insert_undo: not implemented.");
+}
+
+void
+bitmap_redo(XLogRecPtr lsn, XLogRecord* record)
+{
+	uint8	info = record->xl_info & ~XLR_INFO_MASK;
+
+	switch (info)
+	{
+		case XLOG_BITMAP_INSERT_NEWLOV:
+			_bitmap_xlog_newpage(true, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_LOVITEM:
+			_bitmap_xlog_insert_lovitem(true, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_META:
+			_bitmap_xlog_insert_meta(true, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_NEWBITMAP:
+			_bitmap_xlog_newpage(true, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_BITMAP:
+			_bitmap_xlog_insert_bitmap(true, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_BITMAP_LASTWORDS:
+			_bitmap_xlog_insert_bitmap_lastwords(true, lsn, record);
+			break;
+		default:
+			elog(PANIC, "bitmap_redo: unknown op code %u", info);
+	}
+}
+
+void
+bitmap_undo(XLogRecPtr lsn, XLogRecord *record)
+{
+	uint8		info = record->xl_info & ~XLR_INFO_MASK;
+
+	switch (info)
+	{
+		case XLOG_BITMAP_INSERT_NEWLOV:
+			_bitmap_xlog_newpage(false, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_LOVITEM:
+			_bitmap_xlog_insert_lovitem(false, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_META:
+			_bitmap_xlog_insert_meta(false, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_NEWBITMAP:
+			_bitmap_xlog_newpage(false, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_BITMAP:
+			_bitmap_xlog_insert_bitmap(false, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_BITMAP_LASTWORDS:
+			_bitmap_xlog_insert_bitmap_lastwords(false, lsn, record);
+			break;
+
+		default:
+			elog(PANIC, "bitmap_undo: unknown op code %u", info);
+	}
+}
+
+static void
+out_target(char *buf, RelFileNode* node)
+{
+	sprintf(buf + strlen(buf), "rel %u/%u/%u",
+			node->spcNode, node->dbNode, node->relNode);
+}
+
+void
+bitmap_desc(char* buf, uint8 xl_info, char* rec)
+{
+	uint8		info = xl_info & ~XLR_INFO_MASK;
+
+	switch (info)
+	{
+		case XLOG_BITMAP_INSERT_NEWLOV:
+		{
+			xl_bm_newpage *xlrec = (xl_bm_newpage*)rec;
+
+			strcat(buf, "insert a new LOV page: ");
+			out_target(buf, &(xlrec->bm_node));
+			break;
+		}
+		case XLOG_BITMAP_INSERT_LOVITEM:
+		{
+			xl_bm_lovitem *xlrec = (xl_bm_lovitem*)rec;
+
+			strcat(buf, "insert a new LOV item: ");
+			out_target(buf, &(xlrec->bm_node));
+			break;
+		}
+		case XLOG_BITMAP_INSERT_META:
+		{
+			xl_bm_metapage *xlrec = (xl_bm_metapage*)rec;
+
+			strcat(buf, "update the metapage: ");
+			out_target(buf, &(xlrec->bm_node));
+			break;
+		}
+		case XLOG_BITMAP_INSERT_NEWBITMAP:
+		{
+			xl_bm_newpage *xlrec = (xl_bm_newpage*)rec;
+
+			strcat(buf, "insert a new bitmap page: ");
+			out_target(buf, &(xlrec->bm_node));
+			break;
+		}
+		case XLOG_BITMAP_INSERT_BITMAP:
+		{
+			xl_bm_bitmappage *xlrec = (xl_bm_bitmappage*)rec;
+
+			strcat(buf, "update a bitmap page: ");
+			out_target(buf, &(xlrec->bm_node));
+			break;
+		}
+		case XLOG_BITMAP_INSERT_BITMAP_LASTWORDS:
+		{
+			xl_bm_bitmap_lastwords *xlrec = (xl_bm_bitmap_lastwords*)rec;
+
+			strcat(buf, "update the last two words in a bitmap: ");
+			out_target(buf, &(xlrec->bm_node));
+			break;
+		}
+
+		default:
+			strcat(buf, "UNKNOWN");
+			break;
+	}
+}
diff -Naur src.pgsql/backend/access/index/indexam.c src.bizgres/backend/access/index/indexam.c
--- src.pgsql/backend/access/index/indexam.c	2006-07-17 17:05:13.000000000 -0700
+++ src.bizgres/backend/access/index/indexam.c	2006-07-17 22:33:22.000000000 -0700
@@ -3,12 +3,12 @@
  * indexam.c
  *	  general index access method routines
  *
- * Portions Copyright (c) 1996-2006, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1996-2005, PostgreSQL Global Development Group
  * Portions Copyright (c) 1994, Regents of the University of California
  *
  *
  * IDENTIFICATION
- *	  $PostgreSQL: pgsql/src/backend/access/index/indexam.c,v 1.93 2006/05/07 01:21:30 tgl Exp $
+ *	  $PostgreSQL: pgsql/src/backend/access/index/indexam.c,v 1.86 2005/10/15 02:49:09 momjian Exp $
  *
  * INTERFACE ROUTINES
  *		index_open		- open an index relation by relation OID
@@ -16,6 +16,8 @@
  *		index_close		- close an index relation
  *		index_beginscan - start a scan of an index with amgettuple
  *		index_beginscan_multi - start a scan of an index with amgetmulti
+ *		index_beginscan_bitmapwords - start a scan of an index with 
+ *									  amgetbitmapwords
  *		index_rescan	- restart a scan of an index
  *		index_endscan	- end a scan
  *		index_insert	- insert an index tuple into a relation
@@ -23,6 +25,7 @@
  *		index_restrpos	- restore a scan position
  *		index_getnext	- get the next tuple from a scan
  *		index_getmulti	- get multiple tuples from a scan
+ *		index_getbitmapwords - get several bitmap words from a scan
  *		index_bulk_delete	- bulk deletion of index tuples
  *		index_vacuum_cleanup	- post-deletion cleanup of an index
  *		index_getprocid - get a support procedure OID
@@ -287,6 +290,32 @@
 }
 
 /*
+ * index_beginscan_bitmapwords - start a scan of an index 
+ * 								 with amgetbitmapwords
+ *
+ * As above, caller had better be holding some lock on the parent heap
+ * relation, even though it's not explicitly mentioned here.
+ */
+IndexScanDesc
+index_beginscan_bitmapwords(Relation indexRelation,
+							bool need_index_lock,
+							Snapshot snapshot,
+							int nkeys, ScanKey key)
+{
+	IndexScanDesc scan;
+
+	scan = index_beginscan_internal(indexRelation, need_index_lock, nkeys, key);
+
+	/*
+	 * Save additional parameters into the scandesc.  Everything else was
+	 * set up by RelationGetIndexScan.
+	 */
+	scan->xs_snapshot = snapshot;
+
+	return scan;
+}
+
+/*
  * index_beginscan_internal --- common code for index_beginscan variants
  */
 static IndexScanDesc
@@ -599,6 +628,39 @@
 }
 
 /* ----------------
+ *		index_getbitmapwords - get several bitmap words from an index scan.
+ */
+bool
+index_getbitmapwords(IndexScanDesc	scan,
+					 uint32			maxNumOfWords,
+					 uint32			*returnedNumOfWords,
+					 BM_HRL_WORD*	headerWords,
+					 BM_HRL_WORD*	contentWords)
+{
+	FmgrInfo   *procedure;
+	bool		found;
+
+	SCAN_CHECKS;
+	GET_SCAN_PROCEDURE(amgetbitmapwords);
+
+	/* just make sure this is false... */
+	scan->kill_prior_tuple = false;
+
+	/*
+	 * have the am's getbitmapwords proc do all the work. 
+	   index_beginscan_bitmapwords already set up fn_getbitmapwords.
+	 */
+	found = DatumGetBool(FunctionCall5(procedure,
+									   PointerGetDatum(scan),
+									   Int32GetDatum(maxNumOfWords),
+									   PointerGetDatum(returnedNumOfWords),
+									   PointerGetDatum(headerWords),
+									   PointerGetDatum(contentWords)));
+
+	return found;
+}
+
+/* ----------------
  *		index_bulk_delete - do mass deletion of index entries
  *
  *		callback routine tells whether a given main-heap tuple is
diff -Naur src.pgsql/backend/access/transam/rmgr.c src.bizgres/backend/access/transam/rmgr.c
--- src.pgsql/backend/access/transam/rmgr.c	2006-07-17 17:05:13.000000000 -0700
+++ src.bizgres/backend/access/transam/rmgr.c	2006-07-17 22:33:22.000000000 -0700
@@ -3,7 +3,7 @@
  *
  * Resource managers definition
  *
- * $PostgreSQL: pgsql/src/backend/access/transam/rmgr.c,v 1.23 2006/07/11 17:26:58 momjian Exp $
+ * $PostgreSQL: pgsql/src/backend/access/transam/rmgr.c,v 1.20 2005/06/14 11:45:14 teodor Exp $
  */
 #include "postgres.h"
 
@@ -14,6 +14,7 @@
 #include "access/heapam.h"
 #include "access/multixact.h"
 #include "access/nbtree.h"
+#include "access/bitmap.h"
 #include "access/xact.h"
 #include "access/xlog_internal.h"
 #include "commands/dbcommands.h"
@@ -36,7 +37,8 @@
 	{"Heap", heap_redo, heap_desc, NULL, NULL},
 	{"Btree", btree_redo, btree_desc, btree_xlog_startup, btree_xlog_cleanup},
 	{"Hash", hash_redo, hash_desc, NULL, NULL},
-	{"Gin", gin_redo, gin_desc, gin_xlog_startup, gin_xlog_cleanup},
+        {"Gin", gin_redo, gin_desc, gin_xlog_startup, gin_xlog_cleanup},
 	{"Gist", gist_redo, gist_desc, gist_xlog_startup, gist_xlog_cleanup},
-	{"Sequence", seq_redo, seq_desc, NULL, NULL}
+	{"Sequence", seq_redo, seq_desc, NULL, NULL},
+ 	{"Bitmap", bitmap_redo, bitmap_desc, NULL, NULL}
 };
diff -Naur src.pgsql/backend/commands/explain.c src.bizgres/backend/commands/explain.c
--- src.pgsql/backend/commands/explain.c	2006-07-17 17:05:12.000000000 -0700
+++ src.bizgres/backend/commands/explain.c	2006-07-17 22:33:17.000000000 -0700
@@ -621,6 +621,8 @@
 		case T_BitmapIndexScan:
 			appendStringInfo(str, " on %s",
 							 quote_identifier(get_rel_name(((BitmapIndexScan *) plan)->indexid)));
+			if (((BitmapIndexScan *) plan)->indexam == BITMAP_AM_OID)
+				appendStringInfo(str, "(on-disk bitmap index)");
 			break;
 		case T_SubqueryScan:
 			if (((Scan *) plan)->scanrelid > 0)
diff -Naur src.pgsql/backend/commands/vacuum.c src.bizgres/backend/commands/vacuum.c
--- src.pgsql/backend/commands/vacuum.c	2006-07-17 17:05:12.000000000 -0700
+++ src.bizgres/backend/commands/vacuum.c	2006-07-17 22:33:18.000000000 -0700
@@ -1208,8 +1208,13 @@
 		if (vacuum_pages.num_pages > 0)
 		{
 			for (i = 0; i < nindexes; i++)
-				vacuum_index(&vacuum_pages, Irel[i],
-							 vacrelstats->rel_tuples, 0);
+				/*
+				 * We postpone vacuuming an on-disk bitmap index after
+				 * repair_frag().
+				 */
+				if (strcmp(NameStr(Irel[i]->rd_am->amname), "bitmap") != 0)
+					vacuum_index(&vacuum_pages, Irel[i],
+								 vacrelstats->rel_tuples, 0);
 		}
 		else
 		{
@@ -1224,6 +1229,13 @@
 		/* Try to shrink heap */
 		repair_frag(vacrelstats, onerel, &vacuum_pages, &fraged_pages,
 					nindexes, Irel, OldestXmin);
+
+		for (i = 0; i < nindexes; i++)
+			/* Perform re-index for on-disk bitmap indexes. */
+			if (strcmp(NameStr(Irel[i]->rd_am->amname), "bitmap") == 0)
+				vacuum_index(&vacuum_pages, Irel[i],
+							 vacrelstats->rel_tuples, 0);
+
 		vac_close_indexes(nindexes, Irel, NoLock);
 	}
 	else
@@ -2496,8 +2508,10 @@
 			 */
 			Assert(keep_tuples >= 0);
 			for (i = 0; i < nindexes; i++)
-				vacuum_index(&Nvacpagelist, Irel[i],
-							 vacrelstats->rel_tuples, keep_tuples);
+				/* We postpone vacuuming an on-disk bitmap index. */
+				if (strcmp(NameStr(Irel[i]->rd_am->amname), "bitmap") != 0)
+					vacuum_index(&Nvacpagelist, Irel[i],
+								 vacrelstats->rel_tuples, keep_tuples);
 		}
 
 		/*
diff -Naur src.pgsql/backend/executor/execUtils.c src.bizgres/backend/executor/execUtils.c
--- src.pgsql/backend/executor/execUtils.c	2006-07-17 17:05:12.000000000 -0700
+++ src.bizgres/backend/executor/execUtils.c	2006-07-17 22:33:18.000000000 -0700
@@ -977,6 +977,12 @@
 		if (relationDescs[i] == NULL)
 			continue;
 
+		/* if this is called in vacuum, and the index is an on-disk
+			bitmap index, we do nothing. */
+		if (is_vacuum &&
+			strcmp(NameStr(relationDescs[i]->rd_am->amname), "bitmap") ==0)
+			continue;
+
 		indexInfo = indexInfoArray[i];
 
 		/* Check for partial index */
diff -Naur src.pgsql/backend/executor/nodeBitmapAnd.c src.bizgres/backend/executor/nodeBitmapAnd.c
--- src.pgsql/backend/executor/nodeBitmapAnd.c	2006-07-17 17:05:12.000000000 -0700
+++ src.bizgres/backend/executor/nodeBitmapAnd.c	2006-07-17 22:33:18.000000000 -0700
@@ -3,12 +3,12 @@
  * nodeBitmapAnd.c
  *	  routines to handle BitmapAnd nodes.
  *
- * Portions Copyright (c) 1996-2006, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1996-2005, PostgreSQL Global Development Group
  * Portions Copyright (c) 1994, Regents of the University of California
  *
  *
  * IDENTIFICATION
- *	  $PostgreSQL: pgsql/src/backend/executor/nodeBitmapAnd.c,v 1.8 2006/05/30 14:01:58 momjian Exp $
+ *	  $PostgreSQL: pgsql/src/backend/executor/nodeBitmapAnd.c,v 1.4 2005/10/15 02:49:17 momjian Exp $
  *
  *-------------------------------------------------------------------------
  */
@@ -32,7 +32,6 @@
 #include "executor/instrument.h"
 #include "executor/nodeBitmapAnd.h"
 
-
 /* ----------------------------------------------------------------
  *		ExecInitBitmapAnd
  *
@@ -48,6 +47,7 @@
 	int			i;
 	ListCell   *l;
 	Plan	   *initNode;
+	bool		inmem = false;
 
 	/* check for unsupported flags */
 	Assert(!(eflags & (EXEC_FLAG_BACKWARD | EXEC_FLAG_MARK)));
@@ -84,10 +84,26 @@
 	foreach(l, node->bitmapplans)
 	{
 		initNode = (Plan *) lfirst(l);
-		bitmapplanstates[i] = ExecInitNode(initNode, estate, eflags);
+	    bitmapplanstates[i] = ExecInitNode(initNode, estate, eflags);
+
+		if (!inmem && IsA(initNode, BitmapIndexScan))
+			inmem = (((BitmapIndexScan*)initNode)->indexam != 
+					 BITMAP_AM_OID);
+		else if (!inmem && IsA(initNode, BitmapAnd))
+			inmem = ((BitmapAnd*)initNode)->inmem;
+		else if (!inmem && IsA(initNode, BitmapOr))
+			inmem = ((BitmapOr*)initNode)->inmem;
 		i++;
 	}
 
+	node->inmem = inmem;
+
+	bitmapandstate->odbms = (OnDiskBitmapWords**)
+		palloc0(nplans * sizeof(OnDiskBitmapWords*));
+	for (i=0; i<nplans; i++)
+		bitmapandstate->odbms[i] = odbm_create(BM_MAX_WORDS);
+	bitmapandstate->resultOdbm = NULL;
+
 	return bitmapandstate;
 }
 
@@ -112,7 +128,8 @@
 	PlanState **bitmapplans;
 	int			nplans;
 	int			i;
-	TIDBitmap  *result = NULL;
+	Node		*result = NULL;
+	bool		inmem = ((BitmapAnd*)(((PlanState*)node)->plan))->inmem;
 
 	/* must provide our own instrumentation support */
 	if (node->ps.instrument)
@@ -124,36 +141,71 @@
 	bitmapplans = node->bitmapplans;
 	nplans = node->nplans;
 
+
 	/*
 	 * Scan all the subplans and AND their result bitmaps
-	 */
+ 	*/
 	for (i = 0; i < nplans; i++)
 	{
-		PlanState  *subnode = bitmapplans[i];
-		TIDBitmap  *subresult;
+		PlanState	*subnode = bitmapplans[i];
+
+		/* set the required bitmap type for the subnodes */
+		odbm_set_bitmaptype(subnode->plan, inmem);
 
-		subresult = (TIDBitmap *) MultiExecProcNode(subnode);
+		if (inmem) 
+		{
+			TIDBitmap *subresult;
+
+			subresult = (TIDBitmap *) MultiExecProcNode(subnode);
 
-		if (!subresult || !IsA(subresult, TIDBitmap))
-			elog(ERROR, "unrecognized result from subplan");
+			if (!subresult || !IsA(subresult, TIDBitmap))
+				elog(ERROR, "unrecognized result from subplan");
+
+			if (result == NULL)
+				result = (Node*)subresult;			/* first subplan */
+			else
+			{
+				tbm_intersect((TIDBitmap*)result, subresult);
+				tbm_free(subresult);
+			}
+		}
 
-		if (result == NULL)
-			result = subresult; /* first subplan */
 		else
 		{
-			tbm_intersect(result, subresult);
-			tbm_free(subresult);
+			OnDiskBitmapWords* subresult;
+
+			/* if there is no leftover from previous scan, then
+				read next list of words. */
+			if ((node->odbms[i])->bitmapWords.numOfWords == 0)
+			{
+				node->odbms[i]->bitmapWords.startNo = 0;
+				odbm_set_child_resultnode(subnode, node->odbms[i]);
+
+				subresult = (OnDiskBitmapWords*)MultiExecProcNode(subnode);
+
+				if (!subresult || !IsA(subresult, OnDiskBitmapWords))
+					elog(ERROR, "unrecognized result from subplan");
+
+				node->odbms[i] = subresult;
+			}
 		}
+	}
 
-		/*
-		 * If at any stage we have a completely empty bitmap, we can fall out
-		 * without evaluating the remaining subplans, since ANDing them can no
-		 * longer change the result.  (Note: the fact that indxpath.c orders
-		 * the subplans by selectivity should make this case more likely to
-		 * occur.)
-		 */
-		if (tbm_is_empty(result))
-			break;
+	if (!inmem)
+	{
+		BMBatchWords**	batches = (BMBatchWords**)
+			palloc0(nplans* sizeof(BMBatchWords*));
+
+		if (node->resultOdbm == NULL)
+			node->resultOdbm = odbm_create(BM_MAX_WORDS);
+		_bitmap_reset_batchwords(&(node->resultOdbm->bitmapWords));
+
+		for (i=0; i<nplans; i++)
+			batches[i] = &(node->odbms[i]->bitmapWords);
+		_bitmap_intersect(batches, nplans, &(node->resultOdbm->bitmapWords));
+		result = (Node*)(node->resultOdbm);
+
+		pfree(batches);
 	}
 
 	if (result == NULL)
@@ -195,6 +247,14 @@
 		if (bitmapplans[i])
 			ExecEndNode(bitmapplans[i]);
 	}
+
+	if (node->odbms != NULL)
+	{
+		for (i=0; i<nplans; i++)
+			if (node->odbms[i] != NULL)
+				odbm_free(node->odbms[i]);
+		pfree(node->odbms);
+	}
 }
 
 void
@@ -213,6 +273,12 @@
 		if (node->ps.chgParam != NULL)
 			UpdateChangedParamSet(subnode, node->ps.chgParam);
 
+		if (node->odbms[i] != NULL)
+		{
+			node->odbms[i]->bitmapWords.startNo = 0;
+			node->odbms[i]->bitmapWords.numOfWords = 0;
+		}
+
 		/*
 		 * Always rescan the inputs immediately, to ensure we can pass down
 		 * any outer tuple that might be used in index quals.
diff -Naur src.pgsql/backend/executor/nodeBitmapHeapscan.c src.bizgres/backend/executor/nodeBitmapHeapscan.c
--- src.pgsql/backend/executor/nodeBitmapHeapscan.c	2006-07-17 17:05:12.000000000 -0700
+++ src.bizgres/backend/executor/nodeBitmapHeapscan.c	2006-07-17 22:33:18.000000000 -0700
@@ -64,6 +64,10 @@
 	OffsetNumber targoffset;
 	TupleTableSlot *slot;
 
+	OnDiskBitmapWords *odbm;
+	BMIterateResult *odbmres;
+	bool inmem = false;
+
 	/*
 	 * extract necessary information from index scan node
 	 */
@@ -74,6 +78,8 @@
 	scanrelid = ((BitmapHeapScan *) node->ss.ps.plan)->scan.scanrelid;
 	tbm = node->tbm;
 	tbmres = node->tbmres;
+	odbm = node->odbm;
+	odbmres = node->odbmres;
 
 	/*
 	 * Check if we are evaluating PlanQual for tuple of this relation.
@@ -104,6 +110,91 @@
 		return slot;
 	}
 
+	/* check if this requires in-mem bitmap scan or on-disk bitmap index. */
+	inmem = ((BitmapHeapScan*)(((PlanState*)node)->plan))->inmem;
+
+	/*
+	 * If the underline indexes are on disk bitmap indexes
+	 */
+	if (!inmem) {
+		uint64	nextTid = 0;
+
+		if (odbm == NULL)
+		{
+			odbm = odbm_create(BM_MAX_WORDS);
+			node->odbm = odbm;
+		}
+
+		if (odbmres == NULL)
+		{
+			odbmres = odbm_res_create(odbm);
+			node->odbmres = odbmres;
+		}
+
+		for (;;)
+		{
+			/* If we have used up the words from previous scan, or 
+				we haven't scan the underlying index scan for words yet,
+				then do it.
+			 */
+			if (odbm->bitmapWords.numOfWords == 0 &&
+				odbmres->nextTidLoc >= odbmres->numOfTids)
+			{
+
+				Plan* outerPlan = (((PlanState*)node)->lefttree)->plan;
+				odbm_set_bitmaptype(outerPlan, false);
+
+				odbm->bitmapWords.firstTid = odbmres->nextTid;
+				odbm->bitmapWords.startNo = 0;
+				odbm_set_child_resultnode(((PlanState*)node)->lefttree,
+										  odbm);
+				odbm = (OnDiskBitmapWords *)
+					MultiExecProcNode(outerPlanState(node));
+
+				if (!odbm || !IsA(odbm, OnDiskBitmapWords))
+					elog(ERROR, "unrecognized result from subplan");
+
+				_bitmap_begin_iterate(&(node->odbm->bitmapWords), node->odbmres);
+			}
+
+			/* If we can not find more words, then this scan is over. */
+			if (odbm == NULL ||
+				(odbm->bitmapWords.numOfWords == 0 && 
+				 odbmres->nextTidLoc >= odbmres->numOfTids))
+				return ExecClearTuple(slot);
+
+			nextTid = _bitmap_findnexttid(&(odbm->bitmapWords), odbmres);
+
+			if (nextTid == 0)
+				continue;
+
+			ItemPointerSet(&scan->rs_ctup.t_self,
+							(nextTid-1)/MaxNumHeapTuples,
+							((nextTid-1)%MaxNumHeapTuples)+1);
+			/* fetch the heap tuple and see if it matches the snapshot. */
+			if (heap_release_fetch(scan->rs_rd,
+								   scan->rs_snapshot,
+								   &scan->rs_ctup,
+								   &scan->rs_cbuf,
+								   true,
+								   &scan->rs_pgstat_info))
+			{
+				/*
+			 	* Set up the result slot to point to this tuple.
+				 * Note that the slot acquires a pin on the buffer.
+				 */
+				ExecStoreTuple(&scan->rs_ctup,
+							   slot,
+							   scan->rs_cbuf,
+							   false);
+
+			
+				/* return this tuple */
+				return slot;
+			}
+		}
+	}
+
 	/*
 	 * If we haven't yet performed the underlying index scan, do it, and
 	 * prepare the bitmap to be iterated over.
@@ -395,6 +486,10 @@
 	node->tbm = NULL;
 	node->tbmres = NULL;
 
+	if (node->odbm)
+		odbm_free(node->odbm);
+	node->odbm = NULL;
+
 	/*
 	 * Always rescan the input immediately, to ensure we can pass down any
 	 * outer tuple that might be used in index quals.
@@ -440,6 +535,9 @@
 	if (node->tbm)
 		tbm_free(node->tbm);
 
+	if (node->odbm)
+		odbm_free(node->odbm);
+
 	/*
 	 * close heap scan
 	 */
@@ -554,6 +652,17 @@
 	 */
 	outerPlanState(scanstate) = ExecInitNode(outerPlan(node), estate, eflags);
 
+	if (IsA(outerPlan(node), BitmapIndexScan))
+		node->inmem = 
+			(((BitmapIndexScan*)outerPlan(node))->indexam != 
+			 BITMAP_AM_OID);
+	else if (IsA(outerPlan(node), BitmapAnd))
+		node->inmem = ((BitmapAnd*)outerPlan(node))->inmem;
+	else if (IsA(outerPlan(node), BitmapOr))
+		node->inmem = ((BitmapOr*)outerPlan(node))->inmem;
+	else
+		node->inmem = true;
+
 	/*
 	 * all done.
 	 */
